## libgit2 0.27.7+dfsg.1

=== src/CMakeLists.txt ===
IF(DEBUG_POOL)
	SET(GIT_DEBUG_POOL 1)
ENDIF()
ADD_FEATURE_INFO(debugpool GIT_DEBUG_POOL "debug pool allocator")

# This variable will contain the libraries we need to put into
# libgit2.pc's Requires.private. That is, what we're linking to or
# what someone who's statically linking us needs to link to.
SET(LIBGIT2_PC_REQUIRES "")
# This will be set later if we use the system's http-parser library or
# use iconv (OSX) and will be written to the Libs.private field in the
# pc file.
SET(LIBGIT2_PC_LIBS "")

SET(LIBGIT2_INCLUDES
	"${CMAKE_CURRENT_BINARY_DIR}"
	"${libgit2_SOURCE_DIR}/src"
	"${libgit2_SOURCE_DIR}/include")
SET(LIBGIT2_LIBS "")

# Installation paths
#
SET(BIN_INSTALL_DIR bin CACHE PATH "Where to install binaries to.")
SET(LIB_INSTALL_DIR lib CACHE PATH "Where to install libraries to.")
SET(INCLUDE_INSTALL_DIR include CACHE PATH "Where to install headers to.")

# Set a couple variables to be substituted inside the .pc file.
# We can't just use LIB_INSTALL_DIR in the .pc file, as passing them as absolue
# or relative paths is both valid and supported by cmake.
SET (PKGCONFIG_PREFIX ${CMAKE_INSTALL_PREFIX})

IF(IS_ABSOLUTE ${LIB_INSTALL_DIR})
  SET (PKGCONFIG_LIBDIR ${LIB_INSTALL_DIR})
ELSE(IS_ABSOLUTE ${LIB_INSTALL_DIR})
  SET (PKGCONFIG_LIBDIR "\${prefix}/${LIB_INSTALL_DIR}")
ENDIF (IS_ABSOLUTE ${LIB_INSTALL_DIR})

IF(IS_ABSOLUTE ${INCLUDE_INSTALL_DIR})
  SET (PKGCONFIG_INCLUDEDIR ${INCLUDE_INSTALL_DIR})
ELSE(IS_ABSOLUTE ${INCLUDE_INSTALL_DIR})
  SET (PKGCONFIG_INCLUDEDIR "\${prefix}/${INCLUDE_INSTALL_DIR}")
ENDIF(IS_ABSOLUTE ${INCLUDE_INSTALL_DIR})

# Enable tracing
IF (ENABLE_TRACE STREQUAL "ON")
	SET(GIT_TRACE 1)
ENDIF()
ADD_FEATURE_INFO(tracing GIT_TRACE "tracing support")

CHECK_SYMBOL_EXISTS(regcomp_l "regex.h;xlocale.h" HAVE_REGCOMP_L)
IF (HAVE_REGCOMP_L)
	SET(GIT_USE_REGCOMP_L 1)
ENDIF ()

CHECK_FUNCTION_EXISTS(futimens HAVE_FUTIMENS)
IF (HAVE_FUTIMENS)
	SET(GIT_USE_FUTIMENS 1)
ENDIF ()

CHECK_PROTOTYPE_DEFINITION(qsort_r
	"void qsort_r(void *base, size_t nmemb, size_t size, void *thunk, int (*compar)(void *, const void *, const void *))"
	"" "stdlib.h" HAVE_QSORT_R_BSD)
IF (HAVE_QSORT_R_BSD)
	ADD_DEFINITIONS(-DHAVE_QSORT_R_BSD)
ENDIF()

CHECK_PROTOTYPE_DEFINITION(qsort_r
	"void qsort_r(void *base, size_t nmemb, size_t size, int (*compar)(const void *, const void *, void *), void *arg)"
	"" "stdlib.h" HAVE_QSORT_R_GNU)
IF (HAVE_QSORT_R_GNU)
	ADD_DEFINITIONS(-DHAVE_QSORT_R_GNU)
ENDIF()

CHECK_FUNCTION_EXISTS(qsort_s HAVE_QSORT_S)
IF (HAVE_QSORT_S)
	ADD_DEFINITIONS(-DHAVE_QSORT_S)
ENDIF ()

# Find required dependencies

IF(WIN32)
	LIST(APPEND LIBGIT2_LIBS ws2_32)
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
	LIST(APPEND LIBGIT2_LIBS socket nsl)
	LIST(APPEND LIBGIT2_PC_LIBS "-lsocket" "-lnsl")
ELSEIF(CMAKE_SYSTEM_NAME MATCHES "Haiku")
	LIST(APPEND LIBGIT2_LIBS network)
	LIST(APPEND LIBGIT2_PC_LIBS "-lnetwork")
ENDIF()

CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" NEED_LIBRT)
IF(NEED_LIBRT)
	LIST(APPEND LIBGIT2_LIBS rt)
	LIST(APPEND LIBGIT2_PC_LIBS "-lrt")
ENDIF()

IF(THREADSAFE)
	LIST(APPEND LIBGIT2_LIBS ${CMAKE_THREAD_LIBS_INIT})
	LIST(APPEND LIBGIT2_PC_LIBS ${CMAKE_THREAD_LIBS_INIT})
ENDIF()
ADD_FEATURE_INFO(threadsafe THREADSAFE "threadsafe support")


IF (WIN32 AND EMBED_SSH_PATH)
	FILE(GLOB SRC_SSH "${EMBED_SSH_PATH}/src/*.c")
	LIST(APPEND LIBGIT2_INCLUDES "${EMBED_SSH_PATH}/include")
	FILE(WRITE "${EMBED_SSH_PATH}/src/libssh2_config.h" "#define HAVE_WINCNG\n#define LIBSSH2_WINCNG\n#include \"../win32/libssh2_config.h\"")
	SET(GIT_SSH 1)
ENDIF()

IF (WIN32 AND WINHTTP)
	SET(GIT_WINHTTP 1)

	# Since MinGW does not come with headers or an import library for winhttp,
	# we have to include a private header and generate our own import library
	IF (MINGW)
		ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/winhttp" "${libgit2_BINARY_DIR}/deps/winhttp")
		LIST(APPEND LIBGIT2_LIBS winhttp)
		LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/winhttp")
	ELSE()
		LIST(APPEND LIBGIT2_LIBS "winhttp")
		LIST(APPEND LIBGIT2_PC_LIBS "-lwinhttp")
	ENDIF ()

	LIST(APPEND LIBGIT2_LIBS "rpcrt4" "crypt32" "ole32")
	LIST(APPEND LIBGIT2_PC_LIBS "-lrpcrt4" "-lcrypt32" "-lole32")
ELSE ()
	IF (CURL)
		FIND_PKGLIBRARIES(CURL libcurl)
	ENDIF ()
	IF (CURL_FOUND)
		SET(GIT_CURL 1)
		LIST(APPEND LIBGIT2_INCLUDES ${CURL_INCLUDE_DIRS})
		LIST(APPEND LIBGIT2_LIBS ${CURL_LIBRARIES})
		LIST(APPEND LIBGIT2_PC_LIBS ${CURL_LDFLAGS})
	ENDIF()
	ADD_FEATURE_INFO(cURL GIT_CURL "cURL for HTTP proxy support")
ENDIF()

IF (USE_HTTPS)
	IF (CMAKE_SYSTEM_NAME MATCHES "Darwin")
		FIND_PACKAGE(Security)
		FIND_PACKAGE(CoreFoundation)
	ENDIF()

	# Auto-select TLS backend
	IF (USE_HTTPS STREQUAL ON)
		IF (SECURITY_FOUND)
			IF (SECURITY_HAS_SSLCREATECONTEXT)
				SET(HTTPS_BACKEND "SecureTransport")
			ELSE()
				MESSAGE("-- Security framework is too old, falling back to OpenSSL")
				SET(HTTPS_BACKEND "OpenSSL")
			ENDIF()
		ELSEIF (WINHTTP)
			SET(HTTPS_BACKEND "WinHTTP")
		ELSE()
			SET(HTTPS_BACKEND "OpenSSL")
		ENDIF()
	ELSE()
		# Backend was explicitly set
		SET(HTTPS_BACKEND ${USE_HTTPS})
	ENDIF()

	# Check that we can find what's required for the selected backend
	IF (HTTPS_BACKEND STREQUAL "SecureTransport")
		IF (NOT COREFOUNDATION_FOUND)
			MESSAGE(FATAL_ERROR "Cannot use SecureTransport backend, CoreFoundation.framework not found")
		ENDIF()
		IF (NOT SECURITY_FOUND)
			MESSAGE(FATAL_ERROR "Cannot use SecureTransport backend, Security.framework not found")
		ENDIF()
		IF (NOT SECURITY_HAS_SSLCREATECONTEXT)
			MESSAGE(FATAL_ERROR "Cannot use SecureTransport backend, SSLCreateContext not supported")
		ENDIF()

		SET(GIT_SECURE_TRANSPORT 1)
		LIST(APPEND LIBGIT2_INCLUDES ${SECURITY_INCLUDE_DIR})
		LIST(APPEND LIBGIT2_LIBS ${COREFOUNDATION_LIBRARIES} ${SECURITY_LIBRARIES})
		LIST(APPEND LIBGIT2_PC_LIBS ${COREFOUNDATION_LDFLAGS} ${SECURITY_LDFLAGS})
	ELSEIF (HTTPS_BACKEND STREQUAL "OpenSSL")
		FIND_PACKAGE(OpenSSL)

		IF (NOT OPENSSL_FOUND)
			MESSAGE(FATAL_ERROR "Asked for OpenSSL TLS backend, but it wasn't found")
		ENDIF()

		SET(GIT_OPENSSL 1)
		LIST(APPEND LIBGIT2_INCLUDES ${OPENSSL_INCLUDE_DIR})
		LIST(APPEND LIBGIT2_LIBS ${OPENSSL_LIBRARIES})
		LIST(APPEND LIBGIT2_PC_LIBS ${OPENSSL_LDFLAGS})
		LIST(APPEND LIBGIT2_PC_REQUIRES "openssl")
	ELSEIF (HTTPS_BACKEND STREQUAL "WinHTTP")
		# WinHTTP setup was handled in the WinHTTP-specific block above
	ELSE()
		MESSAGE(FATAL_ERROR "Asked for backend ${HTTPS_BACKEND} but it wasn't found")
	ENDIF()

	ADD_FEATURE_INFO(HTTPS ON "using ${HTTPS_BACKEND}")
	SET(GIT_HTTPS 1)
ELSE()
	ADD_FEATURE_INFO(HTTPS OFF "no support")
ENDIF()

# Specify sha1 implementation
IF(SHA1_BACKEND STREQUAL "OpenSSL")
	IF(NOT OPENSSL_FOUND)
		FIND_PACKAGE(OpenSSL)
		IF(NOT OPENSSL_FOUND)
		    MESSAGE(FATAL_ERROR "Requested OpenSSL SHA1 backend, but OpenSSL could not be found")
		ENDIF()
	ENDIF()

	ADD_FEATURE_INFO(SHA ON "using OpenSSL")
	SET(GIT_SHA1_OPENSSL 1)
	IF(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
		LIST(APPEND LIBGIT2_PC_LIBS "-lssl")
	ELSE()
		LIST(APPEND LIBGIT2_PC_REQUIRES "openssl")
	ENDIF()
ELSEIF(SHA1_BACKEND STREQUAL "CollisionDetection")
	ADD_FEATURE_INFO(SHA ON "using CollisionDetection")
	SET(GIT_SHA1_COLLISIONDETECT 1)
	ADD_DEFINITIONS(-DSHA1DC_NO_STANDARD_INCLUDES=1)
	ADD_DEFINITIONS(-DSHA1DC_CUSTOM_INCLUDE_SHA1_C=\"common.h\")
	ADD_DEFINITIONS(-DSHA1DC_CUSTOM_INCLUDE_UBC_CHECK_C=\"common.h\")
	FILE(GLOB SRC_SHA1 hash/hash_collisiondetect.c hash/sha1dc/*)
ELSEIF(SHA1_BACKEND STREQUAL "Generic")
	ADD_FEATURE_INFO(SHA ON "using Generic")
	FILE(GLOB SRC_SHA1 hash/hash_generic.c)
ELSEIF(SHA1_BACKEND STREQUAL "Win32")
	ADD_FEATURE_INFO(SHA ON "using Win32")
	SET(GIT_SHA1_WIN32 1)
	FILE(GLOB SRC_SHA1 hash/hash_win32.c)
ELSEIF(SHA1_BACKEND STREQUAL "CommonCrypto")
	ADD_FEATURE_INFO(SHA ON "using CommonCrypto")
	SET(GIT_SHA1_COMMON_CRYPTO 1)
ELSE()
	MESSAGE(FATAL_ERROR "Asked for unknown SHA1 backend ${SHA1_BACKEND}")
ENDIF()

# Include POSIX regex when it is required
IF(WIN32 OR AMIGA OR CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/regex" "${libgit2_BINARY_DIR}/deps/regex")
	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/regex")
	LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:regex>)
ENDIF()

# Optional external dependency: http-parser
FIND_PACKAGE(HTTP_Parser)
IF (USE_EXT_HTTP_PARSER AND HTTP_PARSER_FOUND AND HTTP_PARSER_VERSION_MAJOR EQUAL 2)
	LIST(APPEND LIBGIT2_INCLUDES ${HTTP_PARSER_INCLUDE_DIRS})
	LIST(APPEND LIBGIT2_LIBS ${HTTP_PARSER_LIBRARIES})
	LIST(APPEND LIBGIT2_PC_LIBS "-lhttp_parser")
	ADD_FEATURE_INFO(http-parser ON "http-parser support")
ELSE()
	MESSAGE(STATUS "http-parser version 2 was not found or disabled; using bundled 3rd-party sources.")
	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/http-parser" "${libgit2_BINARY_DIR}/deps/http-parser")
	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/http-parser")
	LIST(APPEND LIBGIT2_OBJECTS "$<TARGET_OBJECTS:http-parser>")
	ADD_FEATURE_INFO(http-parser ON "http-parser support (bundled)")
ENDIF()

# Optional external dependency: zlib
IF(NOT USE_BUNDLED_ZLIB)
	FIND_PACKAGE(ZLIB)
	IF(ZLIB_FOUND)
		LIST(APPEND LIBGIT2_INCLUDES ${ZLIB_INCLUDE_DIRS})
		LIST(APPEND LIBGIT2_LIBS ${ZLIB_LIBRARIES})
		IF(APPLE OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
			LIST(APPEND LIBGIT2_LIBS "z")
			LIST(APPEND LIBGIT2_PC_LIBS "-lz")
		ELSE()
			LIST(APPEND LIBGIT2_PC_REQUIRES "zlib")
		ENDIF()
		ADD_FEATURE_INFO(zlib ON "using system zlib")
	ELSE()
		MESSAGE(STATUS "zlib was not found; using bundled 3rd-party sources." )
	ENDIF()
ENDIF()
IF(USE_BUNDLED_ZLIB OR NOT ZLIB_FOUND)
	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/zlib" "${libgit2_BINARY_DIR}/deps/zlib")
	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/zlib")
	LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:zlib>)
	ADD_FEATURE_INFO(zlib ON "using bundled zlib")
ENDIF()

# Optional external dependency: libssh2
IF (USE_SSH)
	FIND_PKGLIBRARIES(LIBSSH2 libssh2)
ENDIF()
IF (LIBSSH2_FOUND)
	SET(GIT_SSH 1)
	LIST(APPEND LIBGIT2_INCLUDES ${LIBSSH2_INCLUDE_DIRS})
	LIST(APPEND LIBGIT2_LIBS ${LIBSSH2_LIBRARIES})
	LIST(APPEND LIBGIT2_PC_LIBS ${LIBSSH2_LDFLAGS})

	CHECK_LIBRARY_EXISTS("${LIBSSH2_LIBRARIES}" libssh2_userauth_publickey_frommemory "${LIBSSH2_LIBRARY_DIRS}" HAVE_LIBSSH2_MEMORY_CREDENTIALS)
	IF (HAVE_LIBSSH2_MEMORY_CREDENTIALS)
		SET(GIT_SSH_MEMORY_CREDENTIALS 1)
	ENDIF()
ELSE()
	MESSAGE(STATUS "LIBSSH2 not found. Set CMAKE_PREFIX_PATH if it is installed outside of the default search path.")
ENDIF()
ADD_FEATURE_INFO(SSH GIT_SSH "SSH transport support")

# Optional external dependency: libgssapi
IF (USE_GSSAPI)
	FIND_PACKAGE(GSSAPI)
ENDIF()
IF (GSSAPI_FOUND)
	SET(GIT_GSSAPI 1)
	LIST(APPEND LIBGIT2_LIBS ${GSSAPI_LIBRARIES})
ENDIF()
ADD_FEATURE_INFO(SPNEGO GIT_GSSAPI "SPNEGO authentication support")

# Optional external dependency: iconv
IF (USE_ICONV)
	FIND_PACKAGE(Iconv)
ENDIF()
IF (ICONV_FOUND)
	SET(GIT_USE_ICONV 1)
	LIST(APPEND LIBGIT2_INCLUDES ${ICONV_INCLUDE_DIR})
	LIST(APPEND LIBGIT2_LIBS ${ICONV_LIBRARIES})
	LIST(APPEND LIBGIT2_PC_LIBS ${ICONV_LIBRARIES})
ENDIF()
ADD_FEATURE_INFO(iconv GIT_USE_ICONV "iconv encoding conversion support")


IF (THREADSAFE)
	IF (NOT WIN32)
		FIND_PACKAGE(Threads REQUIRED)
	ENDIF()

	SET(GIT_THREADS 1)
ENDIF()

IF (USE_NSEC)
	SET(GIT_USE_NSEC 1)
ENDIF()

IF (HAVE_STRUCT_STAT_ST_MTIM)
	SET(GIT_USE_STAT_MTIM 1)
ELSEIF (HAVE_STRUCT_STAT_ST_MTIMESPEC)
	SET(GIT_USE_STAT_MTIMESPEC 1)
ELSEIF (HAVE_STRUCT_STAT_ST_MTIME_NSEC)
	SET(GIT_USE_STAT_MTIME_NSEC 1)
ENDIF()

ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=64)

# Collect sourcefiles
FILE(GLOB SRC_H
	"${libgit2_SOURCE_DIR}/include/git2.h"
	"${libgit2_SOURCE_DIR}/include/git2/*.h"
	"${libgit2_SOURCE_DIR}/include/git2/sys/*.h")

# On Windows use specific platform sources
IF (WIN32 AND NOT CYGWIN)
	ADD_DEFINITIONS(-DWIN32 -D_WIN32_WINNT=0x0501)

	IF(MSVC)
		SET(WIN_RC "win32/git2.rc")
	ENDIF()

	FILE(GLOB SRC_OS win32/*.c win32/*.h)
ELSEIF (AMIGA)
	ADD_DEFINITIONS(-DNO_ADDRINFO -DNO_READDIR_R -DNO_MMAP)
ELSE()
	IF (VALGRIND)

=== tests/CMakeLists.txt ===
FIND_PACKAGE(PythonInterp)

IF(NOT PYTHONINTERP_FOUND)
  MESSAGE(FATAL_ERROR "Could not find a python interpeter, which is needed to build the tests. "
    "Make sure python is available, or pass -DBUILD_CLAR=OFF to skip building the tests")
ENDIF()

SET(CLAR_FIXTURES "${CMAKE_CURRENT_SOURCE_DIR}/resources/")
SET(CLAR_PATH "${CMAKE_CURRENT_SOURCE_DIR}")
ADD_DEFINITIONS(-DCLAR_FIXTURE_PATH=\"${CLAR_FIXTURES}\")
ADD_DEFINITIONS(-DCLAR_TMPDIR=\"libgit2_tests\")
ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=64)

INCLUDE_DIRECTORIES(${CLAR_PATH} ${libgit2_BINARY_DIR}/src)
FILE(GLOB_RECURSE SRC_TEST ${CLAR_PATH}/*/*.c ${CLAR_PATH}/*/*.h)
SET(SRC_CLAR "main.c" "clar_libgit2.c" "clar_libgit2_trace.c" "clar_libgit2_timer.c" "clar.c")

IF(MSVC_IDE)
	LIST(APPEND SRC_CLAR "precompiled.c")
ENDIF()

ADD_CUSTOM_COMMAND(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/clar.suite
	COMMAND ${PYTHON_EXECUTABLE} generate.py -o "${CMAKE_CURRENT_BINARY_DIR}" -f -xonline -xstress -xperf .
	DEPENDS ${SRC_TEST}
	WORKING_DIRECTORY ${CLAR_PATH}
)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

SET_SOURCE_FILES_PROPERTIES(
	${CLAR_PATH}/clar.c
	PROPERTIES OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/clar.suite)

INCLUDE_DIRECTORIES(${LIBGIT2_INCLUDES})

ADD_EXECUTABLE(libgit2_clar ${SRC_CLAR} ${SRC_TEST} ${LIBGIT2_OBJECTS})

SET_TARGET_PROPERTIES(libgit2_clar PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${libgit2_BINARY_DIR})

IF (${CMAKE_VERSION} VERSION_LESS 2.8.12)
	# Already handled by a global INCLUDE_DIRECTORY()
ELSE()
	TARGET_INCLUDE_DIRECTORIES(libgit2_clar PRIVATE ../src PUBLIC ../include)
ENDIF()

TARGET_LINK_LIBRARIES(libgit2_clar ${LIBGIT2_LIBS})
IDE_SPLIT_SOURCES(libgit2_clar)

IF (MSVC_IDE)
	# Precompiled headers
	SET_TARGET_PROPERTIES(libgit2_clar PROPERTIES COMPILE_FLAGS "/Yuprecompiled.h /FIprecompiled.h")
	SET_SOURCE_FILES_PROPERTIES("precompiled.c" COMPILE_FLAGS "/Ycprecompiled.h")
ENDIF ()

ADD_TEST(offline   "${libgit2_BINARY_DIR}/libgit2_clar" -v -xonline)
ADD_TEST(online    "${libgit2_BINARY_DIR}/libgit2_clar" -v -sonline)
ADD_TEST(gitdaemon "${libgit2_BINARY_DIR}/libgit2_clar" -v -sonline::push)
ADD_TEST(ssh       "${libgit2_BINARY_DIR}/libgit2_clar" -v -sonline::push -sonline::clone::ssh_cert -sonline::clone::ssh_with_paths)
ADD_TEST(proxy     "${libgit2_BINARY_DIR}/libgit2_clar" -v -sonline::clone::proxy_credentials_in_url -sonline::clone::proxy_credentials_request)

=== debian/changelog ===
libgit2 (0.27.7+dfsg.1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix another segfault that was affecting cargo. (Closes: #918854)

 -- Ximin Luo <infinity0@debian.org>  Sat, 18 May 2019 20:05:35 -0700

libgit2 (0.27.7+dfsg.1-0.1) unstable; urgency=high

  * Non-maintainer upload.
  * New upstream release (Closes: #917176)

 -- Raju Devidas <rajudev@disroot.org>  Wed, 26 Dec 2018 22:59:30 +0530

=== debian/control ===
Source: libgit2
Section: libs
Priority: optional
Maintainer: Russell Sim <russell.sim@gmail.com>
Build-Depends: debhelper (>= 11~),
               python-minimal (>= 2.4.0), pkg-config,
               cmake, libz-dev, libmbedtls-dev,
               libssh2-1-dev, libhttp-parser-dev, libkrb5-dev
Standards-Version: 4.3.0
Homepage: https://libgit2.github.com/
Vcs-Git: https://salsa.debian.org/debian/libgit2.git
Vcs-Browser: https://salsa.debian.org/debian/libgit2


Package: libgit2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libgit2-27 (= ${binary:Version}), libz-dev,
         libmbedtls-dev, libssh2-1-dev,
         libhttp-parser-dev, ${shlibs:Depends}, ${misc:Depends}
Description: low-level Git library (development files)
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains the development files for libgit2.

Package: libgit2-27
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: low-level Git library
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.

## libgit2 0.28.1+dfsg.1

=== debian/changelog ===
libgit2 (0.28.1+dfsg.1-0.1) experimental; urgency=medium

  * Non-maintainer upload
  * New upstream version 0.28.1+dfsg.1
  * Library transition from 27 to 28
  * Remove resolved patches with new upstream version
  * Remove nonexistent document

 -- Jongmin Kim <jmkim@pukyong.ac.kr>  Sun, 12 May 2019 02:53:10 +0900

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libgit2-27 (= ${binary:Version}), libz-dev,
+Depends: libgit2-28 (= ${binary:Version}), libz-dev,
          libmbedtls-dev, libssh2-1-dev,
          libhttp-parser-dev, ${shlibs:Depends}, ${misc:Depends}
 Description: low-level Git library (development files)
@@ -26,7 +26,7 @@
  .
  This package contains the development files for libgit2.
 
-Package: libgit2-27
+Package: libgit2-28
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}

## libgit2 0.28.3+dfsg.1

=== debian/changelog ===
libgit2 (0.28.3+dfsg.1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Abhijith Sheheer <abhijithsheheer@gmail.com>  Sat, 23 Nov 2019 10:18:30 +0000

libgit2 (0.28.3+dfsg.1-1) unstable; urgency=medium

  * Reupload to unstable (transition: #934927)
  * Add myself and Russel as Uploaders and Jongmin as Maintainer
    (Closes: #928971)
  * Bump Standards-Version to 4.4.1 (no changes needed)

 -- Pirate Praveen <praveen@debian.org>  Sat, 16 Nov 2019 11:21:02 +0530

libgit2 (0.28.3+dfsg.1-0.1) experimental; urgency=medium

  * Non-maintainer upload
  * New upstream version 0.28.3+dfsg.1

 -- Pirate Praveen <praveen@debian.org>  Fri, 15 Nov 2019 22:07:23 +0530

libgit2 (0.28.1+dfsg.1-0.1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Pirate Praveen <praveen@debian.org>  Sun, 12 May 2019 20:37:02 +0530

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: libgit2
 Section: libs
 Priority: optional
-Maintainer: Russell Sim <russell.sim@gmail.com>
+Maintainer: Jongmin Kim <jmkim@pukyong.ac.kr>
+Uploaders: Russell Sim <russell.sim@gmail.com>,
+ Pirate Praveen <praveen@debian.org>
 Build-Depends: debhelper (>= 11~),
                python-minimal (>= 2.4.0), pkg-config,
                cmake, libz-dev, libmbedtls-dev,
                libssh2-1-dev, libhttp-parser-dev, libkrb5-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: https://libgit2.github.com/
 Vcs-Git: https://salsa.debian.org/debian/libgit2.git
 Vcs-Browser: https://salsa.debian.org/debian/libgit2

## libgit2 0.28.4+dfsg.1

=== examples/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${LIBGIT2_INCLUDES})
INCLUDE_DIRECTORIES(SYSTEM ${LIBGIT2_SYSTEM_INCLUDES})

FILE(GLOB_RECURSE SRC_EXAMPLE_GIT2 network/*.c network/*.h common.?)
ADD_EXECUTABLE(cgit2 ${SRC_EXAMPLE_GIT2})
SET_TARGET_PROPERTIES(cgit2 PROPERTIES C_STANDARD 90)

# Ensure that we do not use deprecated functions internally
ADD_DEFINITIONS(-DGIT_DEPRECATE_HARD)

IF(WIN32 OR ANDROID)
	TARGET_LINK_LIBRARIES(cgit2 git2)
ELSE()
	TARGET_LINK_LIBRARIES(cgit2 git2 pthread)
ENDIF()

FILE(GLOB SRC_EXAMPLE_APPS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.c)
FOREACH(src_app ${SRC_EXAMPLE_APPS})
	STRING(REPLACE ".c" "" app_name ${src_app})
	IF(NOT ${app_name} STREQUAL "common")
		ADD_EXECUTABLE(${app_name} ${src_app} "common.c")
		TARGET_LINK_LIBRARIES(${app_name} git2)
		SET_TARGET_PROPERTIES(${app_name} PROPERTIES C_STANDARD 90)
	ENDIF()
ENDFOREACH()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 	"${CMAKE_CURRENT_BINARY_DIR}"
 	"${libgit2_SOURCE_DIR}/src"
 	"${libgit2_SOURCE_DIR}/include")
+SET(LIBGIT2_SYSTEM_INCLUDES "")
 SET(LIBGIT2_LIBS "")
 
 # Installation paths
@@ -47,10 +48,22 @@
 ENDIF()
 ADD_FEATURE_INFO(tracing GIT_TRACE "tracing support")
 
+# Use `regcomp_l` if available
 CHECK_SYMBOL_EXISTS(regcomp_l "regex.h;xlocale.h" HAVE_REGCOMP_L)
 IF (HAVE_REGCOMP_L)
 	SET(GIT_USE_REGCOMP_L 1)
 ENDIF ()
+
+# Otherwise, we either want to use system's `regcomp` or our
+# bundled regcomp code, if system doesn't provide `regcomp`.
+IF(NOT HAVE_REGCOMP_L)
+	CHECK_FUNCTION_EXISTS(regcomp HAVE_REGCOMP)
+	IF(NOT HAVE_REGCOMP)
+		ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/regex" "${libgit2_BINARY_DIR}/deps/regex")
+		LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/regex")
+		LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:regex>)
+	ENDIF()
+ENDIF()
 
 CHECK_FUNCTION_EXISTS(futimens HAVE_FUTIMENS)
 IF (HAVE_FUTIMENS)
@@ -103,7 +116,7 @@
 
 IF (WIN32 AND EMBED_SSH_PATH)
 	FILE(GLOB SRC_SSH "${EMBED_SSH_PATH}/src/*.c")
-	LIST(APPEND LIBGIT2_INCLUDES "${EMBED_SSH_PATH}/include")
+	LIST(APPEND LIBGIT2_SYSTEM_INCLUDES "${EMBED_SSH_PATH}/include")
 	FILE(WRITE "${EMBED_SSH_PATH}/src/libssh2_config.h" "#define HAVE_WINCNG\n#define LIBSSH2_WINCNG\n#include \"../win32/libssh2_config.h\"")
 	SET(GIT_SSH 1)
 ENDIF()
@@ -124,20 +137,12 @@
 
 	LIST(APPEND LIBGIT2_LIBS "rpcrt4" "crypt32" "ole32")
 	LIST(APPEND LIBGIT2_PC_LIBS "-lrpcrt4" "-lcrypt32" "-lole32")
-ELSE ()
-	IF (CURL)
-		FIND_PKGLIBRARIES(CURL libcurl)
-	ENDIF ()
-	IF (CURL_FOUND)
-		SET(GIT_CURL 1)
-		LIST(APPEND LIBGIT2_INCLUDES ${CURL_INCLUDE_DIRS})
-		LIST(APPEND LIBGIT2_LIBS ${CURL_LIBRARIES})
-		LIST(APPEND LIBGIT2_PC_LIBS ${CURL_LDFLAGS})
-	ENDIF()
-	ADD_FEATURE_INFO(cURL GIT_CURL "cURL for HTTP proxy support")
 ENDIF()
 
 IF (USE_HTTPS)
+	# We try to find any packages our backends might use
+	FIND_PACKAGE(OpenSSL)
+	FIND_PACKAGE(mbedTLS)
 	IF (CMAKE_SYSTEM_NAME MATCHES "Darwin")
 		FIND_PACKAGE(Security)
 		FIND_PACKAGE(CoreFoundation)
@@ -154,8 +159,13 @@
 			ENDIF()
 		ELSEIF (WINHTTP)
 			SET(HTTPS_BACKEND "WinHTTP")
+		ELSEIF(OPENSSL_FOUND)
+			SET(HTTPS_BACKEND "OpenSSL")
+		ELSEIF(MBEDTLS_FOUND)
+			SET(HTTPS_BACKEND "mbedTLS")
 		ELSE()
-			SET(HTTPS_BACKEND "OpenSSL")
+			MESSAGE(FATAL_ERROR "Unable to autodetect a usable HTTPS backend."
+				"Please pass the backend name explicitly (-DUSE_HTTPS=backend)")
 		ENDIF()
 	ELSE()
 		# Backend was explicitly set
@@ -175,21 +185,68 @@
 		ENDIF()
 
 		SET(GIT_SECURE_TRANSPORT 1)
-		LIST(APPEND LIBGIT2_INCLUDES ${SECURITY_INCLUDE_DIR})
+		LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${SECURITY_INCLUDE_DIR})
 		LIST(APPEND LIBGIT2_LIBS ${COREFOUNDATION_LIBRARIES} ${SECURITY_LIBRARIES})
 		LIST(APPEND LIBGIT2_PC_LIBS ${COREFOUNDATION_LDFLAGS} ${SECURITY_LDFLAGS})
 	ELSEIF (HTTPS_BACKEND STREQUAL "OpenSSL")
-		FIND_PACKAGE(OpenSSL)
-
 		IF (NOT OPENSSL_FOUND)
 			MESSAGE(FATAL_ERROR "Asked for OpenSSL TLS backend, but it wasn't found")
 		ENDIF()
 
 		SET(GIT_OPENSSL 1)
-		LIST(APPEND LIBGIT2_INCLUDES ${OPENSSL_INCLUDE_DIR})
+		LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${OPENSSL_INCLUDE_DIR})
 		LIST(APPEND LIBGIT2_LIBS ${OPENSSL_LIBRARIES})
 		LIST(APPEND LIBGIT2_PC_LIBS ${OPENSSL_LDFLAGS})
 		LIST(APPEND LIBGIT2_PC_REQUIRES "openssl")
+	ELSEIF(HTTPS_BACKEND STREQUAL "mbedTLS")
+		IF (NOT MBEDTLS_FOUND)
+			MESSAGE(FATAL_ERROR "Asked for mbedTLS backend, but it wasn't found")
+		ENDIF()
+
+		IF(NOT CERT_LOCATION)
+			MESSAGE("Auto-detecting default certificates location")
+			IF(CMAKE_SYSTEM_NAME MATCHES Darwin)
+				# Check for an Homebrew installation
+				SET(OPENSSL_CMD "/usr/local/opt/openssl/bin/openssl")
+			ELSE()
+				SET(OPENSSL_CMD "openssl")
+			ENDIF()
+			EXECUTE_PROCESS(COMMAND ${OPENSSL_CMD} version -d OUTPUT_VARIABLE OPENSSL_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+			IF(OPENSSL_DIR)
+				STRING(REGEX REPLACE "^OPENSSLDIR: \"(.*)\"$" "\\1/" OPENSSL_DIR ${OPENSSL_DIR})
+
+				SET(OPENSSL_CA_LOCATIONS
+					"ca-bundle.pem"             # OpenSUSE Leap 42.1
+					"cert.pem"                  # Ubuntu 14.04, FreeBSD
+					"certs/ca-certificates.crt" # Ubuntu 16.04
+					"certs/ca.pem"              # Debian 7
+				)
+				FOREACH(SUFFIX IN LISTS OPENSSL_CA_LOCATIONS)
+					SET(LOC "${OPENSSL_DIR}${SUFFIX}")
+					IF(NOT CERT_LOCATION AND EXISTS "${OPENSSL_DIR}${SUFFIX}")
+						SET(CERT_LOCATION ${LOC})
+					ENDIF()
+				ENDFOREACH()
+			ELSE()
+				MESSAGE("Unable to find OpenSSL executable. Please provide default certificate location via CERT_LOCATION")
+			ENDIF()
+		ENDIF()
+
+		IF(CERT_LOCATION)
+			IF(NOT EXISTS ${CERT_LOCATION})
+				MESSAGE(FATAL_ERROR "Cannot use CERT_LOCATION=${CERT_LOCATION} as it doesn't exist")
+			ENDIF()
+			ADD_FEATURE_INFO(CERT_LOCATION ON "using certificates from ${CERT_LOCATION}")
+			ADD_DEFINITIONS(-DGIT_DEFAULT_CERT_LOCATION="${CERT_LOCATION}")
+		ENDIF()
+
+		SET(GIT_MBEDTLS 1)
+		LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${MBEDTLS_INCLUDE_DIR})
+		LIST(APPEND LIBGIT2_LIBS ${MBEDTLS_LIBRARIES})
+		# mbedTLS has no pkgconfig file, hence we can't require it
+		# https://github.com/ARMmbed/mbedtls/issues/228
+		# For now, pass its link flags as our own
+		LIST(APPEND LIBGIT2_PC_LIBS ${MBEDTLS_LIBRARIES})
 	ELSEIF (HTTPS_BACKEND STREQUAL "WinHTTP")
 		# WinHTTP setup was handled in the WinHTTP-specific block above
 	ELSE()
@@ -235,21 +292,24 @@
 ELSEIF(SHA1_BACKEND STREQUAL "CommonCrypto")
 	ADD_FEATURE_INFO(SHA ON "using CommonCrypto")
 	SET(GIT_SHA1_COMMON_CRYPTO 1)
+ELSEIF (SHA1_BACKEND STREQUAL "mbedTLS")
+	ADD_FEATURE_INFO(SHA ON "using mbedTLS")
+	SET(GIT_SHA1_MBEDTLS 1)
+	FILE(GLOB SRC_SHA1 hash/hash_mbedtls.c)
+	LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${MBEDTLS_INCLUDE_DIR})
+	LIST(APPEND LIBGIT2_LIBS ${MBEDTLS_LIBRARIES})
+	# mbedTLS has no pkgconfig file, hence we can't require it
+	# https://github.com/ARMmbed/mbedtls/issues/228
+	# For now, pass its link flags as our own
+	LIST(APPEND LIBGIT2_PC_LIBS ${MBEDTLS_LIBRARIES})
 ELSE()
 	MESSAGE(FATAL_ERROR "Asked for unknown SHA1 backend ${SHA1_BACKEND}")
-ENDIF()
-
-# Include POSIX regex when it is required
-IF(WIN32 OR AMIGA OR CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
-	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/regex" "${libgit2_BINARY_DIR}/deps/regex")
-	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/regex")
-	LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:regex>)
 ENDIF()
 
 # Optional external dependency: http-parser
 FIND_PACKAGE(HTTP_Parser)
 IF (USE_EXT_HTTP_PARSER AND HTTP_PARSER_FOUND AND HTTP_PARSER_VERSION_MAJOR EQUAL 2)
-	LIST(APPEND LIBGIT2_INCLUDES ${HTTP_PARSER_INCLUDE_DIRS})
+	LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${HTTP_PARSER_INCLUDE_DIRS})
 	LIST(APPEND LIBGIT2_LIBS ${HTTP_PARSER_LIBRARIES})
 	LIST(APPEND LIBGIT2_PC_LIBS "-lhttp_parser")
 	ADD_FEATURE_INFO(http-parser ON "http-parser support")
@@ -265,7 +325,7 @@
 IF(NOT USE_BUNDLED_ZLIB)
 	FIND_PACKAGE(ZLIB)
 	IF(ZLIB_FOUND)
-		LIST(APPEND LIBGIT2_INCLUDES ${ZLIB_INCLUDE_DIRS})
+		LIST(APPEND LIBGIT2_SYSTEM_INCLUDES ${ZLIB_INCLUDE_DIRS})
 		LIST(APPEND LIBGIT2_LIBS ${ZLIB_LIBRARIES})
 		IF(APPLE OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
 			LIST(APPEND LIBGIT2_LIBS "z")
@@ -275,96 +335,3 @@
 		ENDIF()
 		ADD_FEATURE_INFO(zlib ON "using system zlib")
 	ELSE()
-		MESSAGE(STATUS "zlib was not found; using bundled 3rd-party sources." )
-	ENDIF()
-ENDIF()
-IF(USE_BUNDLED_ZLIB OR NOT ZLIB_FOUND)
-	ADD_SUBDIRECTORY("${libgit2_SOURCE_DIR}/deps/zlib" "${libgit2_BINARY_DIR}/deps/zlib")
-	LIST(APPEND LIBGIT2_INCLUDES "${libgit2_SOURCE_DIR}/deps/zlib")
-	LIST(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:zlib>)
-	ADD_FEATURE_INFO(zlib ON "using bundled zlib")
-ENDIF()
-
-# Optional external dependency: libssh2
-IF (USE_SSH)
-	FIND_PKGLIBRARIES(LIBSSH2 libssh2)
-ENDIF()
-IF (LIBSSH2_FOUND)
-	SET(GIT_SSH 1)
-	LIST(APPEND LIBGIT2_INCLUDES ${LIBSSH2_INCLUDE_DIRS})
-	LIST(APPEND LIBGIT2_LIBS ${LIBSSH2_LIBRARIES})
-	LIST(APPEND LIBGIT2_PC_LIBS ${LIBSSH2_LDFLAGS})
-
-	CHECK_LIBRARY_EXISTS("${LIBSSH2_LIBRARIES}" libssh2_userauth_publickey_frommemory "${LIBSSH2_LIBRARY_DIRS}" HAVE_LIBSSH2_MEMORY_CREDENTIALS)
-	IF (HAVE_LIBSSH2_MEMORY_CREDENTIALS)
-		SET(GIT_SSH_MEMORY_CREDENTIALS 1)
-	ENDIF()
-ELSE()
-	MESSAGE(STATUS "LIBSSH2 not found. Set CMAKE_PREFIX_PATH if it is installed outside of the default search path.")
-ENDIF()
-ADD_FEATURE_INFO(SSH GIT_SSH "SSH transport support")
-
-# Optional external dependency: libgssapi
-IF (USE_GSSAPI)
-	FIND_PACKAGE(GSSAPI)
-ENDIF()
-IF (GSSAPI_FOUND)
-	SET(GIT_GSSAPI 1)
-	LIST(APPEND LIBGIT2_LIBS ${GSSAPI_LIBRARIES})
-ENDIF()
-ADD_FEATURE_INFO(SPNEGO GIT_GSSAPI "SPNEGO authentication support")
-
-# Optional external dependency: iconv
-IF (USE_ICONV)
-	FIND_PACKAGE(Iconv)
-ENDIF()
-IF (ICONV_FOUND)
-	SET(GIT_USE_ICONV 1)
-	LIST(APPEND LIBGIT2_INCLUDES ${ICONV_INCLUDE_DIR})
-	LIST(APPEND LIBGIT2_LIBS ${ICONV_LIBRARIES})
-	LIST(APPEND LIBGIT2_PC_LIBS ${ICONV_LIBRARIES})
-ENDIF()
-ADD_FEATURE_INFO(iconv GIT_USE_ICONV "iconv encoding conversion support")
-
-
-IF (THREADSAFE)
-	IF (NOT WIN32)
-		FIND_PACKAGE(Threads REQUIRED)
-	ENDIF()
-
-	SET(GIT_THREADS 1)
-ENDIF()
-
-IF (USE_NSEC)
-	SET(GIT_USE_NSEC 1)
-ENDIF()
-
-IF (HAVE_STRUCT_STAT_ST_MTIM)
-	SET(GIT_USE_STAT_MTIM 1)
-ELSEIF (HAVE_STRUCT_STAT_ST_MTIMESPEC)
-	SET(GIT_USE_STAT_MTIMESPEC 1)
-ELSEIF (HAVE_STRUCT_STAT_ST_MTIME_NSEC)
-	SET(GIT_USE_STAT_MTIME_NSEC 1)
-ENDIF()
-
-ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=64)
-
-# Collect sourcefiles
-FILE(GLOB SRC_H
-	"${libgit2_SOURCE_DIR}/include/git2.h"
-	"${libgit2_SOURCE_DIR}/include/git2/*.h"
-	"${libgit2_SOURCE_DIR}/include/git2/sys/*.h")
-
-# On Windows use specific platform sources
-IF (WIN32 AND NOT CYGWIN)
-	ADD_DEFINITIONS(-DWIN32 -D_WIN32_WINNT=0x0501)
-
-	IF(MSVC)
-		SET(WIN_RC "win32/git2.rc")
-	ENDIF()
-
-	FILE(GLOB SRC_OS win32/*.c win32/*.h)
-ELSEIF (AMIGA)
-	ADD_DEFINITIONS(-DNO_ADDRINFO -DNO_READDIR_R -DNO_MMAP)
-ELSE()
-	IF (VALGRIND)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,9 @@
 ADD_DEFINITIONS(-DCLAR_FIXTURE_PATH=\"${CLAR_FIXTURES}\")
 ADD_DEFINITIONS(-DCLAR_TMPDIR=\"libgit2_tests\")
 ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=64)
+
+# Ensure that we do not use deprecated functions internally
+ADD_DEFINITIONS(-DGIT_DEPRECATE_HARD)
 
 INCLUDE_DIRECTORIES(${CLAR_PATH} ${libgit2_BINARY_DIR}/src)
 FILE(GLOB_RECURSE SRC_TEST ${CLAR_PATH}/*/*.c ${CLAR_PATH}/*/*.h)
@@ -32,9 +35,11 @@
 	PROPERTIES OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/clar.suite)
 
 INCLUDE_DIRECTORIES(${LIBGIT2_INCLUDES})
+INCLUDE_DIRECTORIES(SYSTEM ${LIBGIT2_SYSTEM_INCLUDES})
 
 ADD_EXECUTABLE(libgit2_clar ${SRC_CLAR} ${SRC_TEST} ${LIBGIT2_OBJECTS})
 
+SET_TARGET_PROPERTIES(libgit2_clar PROPERTIES C_STANDARD 90)
 SET_TARGET_PROPERTIES(libgit2_clar PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${libgit2_BINARY_DIR})
 
 IF (${CMAKE_VERSION} VERSION_LESS 2.8.12)
@@ -53,6 +58,7 @@
 ENDIF ()
 
 ADD_TEST(offline   "${libgit2_BINARY_DIR}/libgit2_clar" -v -xonline)
+ADD_TEST(invasive  "${libgit2_BINARY_DIR}/libgit2_clar" -v -score::ftruncate -sfilter::stream::bigfile -sodb::largefiles -siterator::workdir::filesystem_gunk -srepo::init -srepo::init::at_filesystem_root)
 ADD_TEST(online    "${libgit2_BINARY_DIR}/libgit2_clar" -v -sonline)
 ADD_TEST(gitdaemon "${libgit2_BINARY_DIR}/libgit2_clar" -v -sonline::push)
 ADD_TEST(ssh       "${libgit2_BINARY_DIR}/libgit2_clar" -v -sonline::push -sonline::clone::ssh_cert -sonline::clone::ssh_with_paths)

=== debian/changelog ===
libgit2 (0.28.4+dfsg.1-2ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: Improper Verification of Cryptographic Signature
    - debian/patches/CVE-2023-22742.patch: perform host key checking
      by default when using ssh.
    - CVE-2023-22742
  * SECURITY UPDATE: use-after-free
    - debian/patches/CVE-2024-24577.patch: correct index check in
      has_dir_name function used by git_index_add.
    - CVE-2024-24577

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Wed, 28 Feb 2024 08:18:43 +0100

libgit2 (0.28.4+dfsg.1-2) unstable; urgency=medium

  * Re-upload to unstable

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 14 Feb 2020 05:17:15 +0530

libgit2 (0.28.4+dfsg.1-1) experimental; urgency=medium

  * New upstream version 0.28.4+dfsg.1
  * Replace libz-dev with zlib1g-dev
  * Replace python-minimal with python3-minimal (Closes: #936866)
  * Make libgit2 cross buildable (Closes: #913241)
  * Add myself as the maintainer
  * Beautify d/control
  * Bump debhelper-compat to 12
  * Bump Standards-Version to 4.5.0

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 14 Feb 2020 02:43:40 +0530

=== debian/control ===
Source: libgit2
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Utkarsh Gupta <utkarsh@debian.org>
Uploaders: Russell Sim <russell.sim@gmail.com>,
           Pirate Praveen <praveen@debian.org>
Build-Depends: debhelper-compat (= 12),
               python3-minimal:any,
               pkg-config,
               cmake,
               zlib1g-dev,
               libmbedtls-dev,
               libssh2-1-dev,
               libhttp-parser-dev,
               libkrb5-dev
Standards-Version: 4.5.0
Homepage: https://libgit2.github.com/
Vcs-Git: https://salsa.debian.org/debian/libgit2.git
Vcs-Browser: https://salsa.debian.org/debian/libgit2


Package: libgit2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libgit2-28 (= ${binary:Version}),
         zlib1g-dev,
         libmbedtls-dev,
         libssh2-1-dev,
         libhttp-parser-dev,
         ${shlibs:Depends},
         ${misc:Depends}
Description: low-level Git library (development files)
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains the development files for libgit2.

Package: libgit2-28
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: low-level Git library
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.

## libgit2 0.28.5+dfsg.1

=== debian/changelog ===
libgit2 (0.28.5+dfsg.1-1) unstable; urgency=medium

  * New upstream version 0.28.5+dfsg.1

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 10 Apr 2020 23:03:48 +0530

libgit2 (0.28.4+dfsg.1-4) unstable; urgency=medium

  * Add BD on ca-certificates to fix FTBFS (Closes: #954529)
    (Thanks to Sudip Mukherjee for his help :))

 -- Utkarsh Gupta <utkarsh@debian.org>  Mon, 23 Mar 2020 19:52:32 +0530

libgit2 (0.28.4+dfsg.1-3) unstable; urgency=medium

  [ Dan Nicholson ]
  * Use mbedTLS with standard CA certificate location (Closes: #927889)

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 13 Mar 2020 02:00:49 +0530

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: libgit2
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Utkarsh Gupta <utkarsh@debian.org>
+Maintainer: Utkarsh Gupta <utkarsh@debian.org>
 Uploaders: Russell Sim <russell.sim@gmail.com>,
            Pirate Praveen <praveen@debian.org>
 Build-Depends: debhelper-compat (= 12),
                python3-minimal:any,
                pkg-config,
+               ca-certificates,
                cmake,
                zlib1g-dev,
                libmbedtls-dev,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This rules file has 2 streams, the build-debian-devel stream builds
# the static library and the bulid-debian-release builds the dynamic
# library.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TEST_TMPDIR := $(CURDIR)/tmp-test
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-debian-release -- \
		-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
		-DUSE_OPENSSL:BOOL=OFF \
		-DUSE_HTTPS=mbedTLS \
		-DCERT_LOCATION=/etc/ssl/certs/ca-certificates.crt \
		-DUSE_CURL_SSL:BOOL=ON \
		-DUSE_GSSAPI:BOOL=ON \
		-DTHREADSAFE:BOOL=ON \
		-DBUILD_CLAR:BOOL=ON \
		-DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)

	dh_auto_configure --builddirectory=build-debian-devel -- \
		-DCMAKE_BUILD_TYPE:STRING=Release \
		-DTHREADSAFE:BOOL=ON \
		-DUSE_HTTPS=mbedTLS \
		-DCERT_LOCATION=/etc/ssl/certs/ca-certificates.crt \
		-DUSE_CURL_SSL:BOOL=ON \
		-DUSE_GSSAPI:BOOL=ON \
		-DBUILD_CLAR:BOOL=OFF \
		-DBUILD_SHARED_LIBS:BOOL=OFF \
		-DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)


override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_auto_build:
	dh_auto_build --builddirectory=build-debian-release
	dh_auto_build --builddirectory=build-debian-devel

override_dh_auto_install:
	dh_auto_install --builddirectory=build-debian-release
	dh_auto_install --builddirectory=build-debian-devel

override_dh_auto_test:
	mkdir -p build-debian-release/tmp
	dh_auto_test --builddirectory=build-debian-release
	mkdir -p build-debian-devel/tmp
	dh_auto_test --builddirectory=build-debian-devel

override_dh_strip:
	dh_strip --dbgsym-migration='libgit2-dbg (<< 0.26.0+dfsg.1-1~)'

override_dh_installexamples:
	dh_installexamples --exclude .gitignore

%:
	dh $@ --buildsystem cmake --dbgsym-migration='libgit2-dbg (<< 0.26.0+dfsg.1-1~)' --builddirectory=build-debian-release
	dh $@ --buildsystem cmake --builddirectory=build-debian-devel

## libgit2 1.0.1

=== deps/ntlmclient/CMakeLists.txt ===
FILE(GLOB SRC_NTLMCLIENT "ntlm.c" "unicode_builtin.c" "util.c")

ADD_DEFINITIONS(-DNTLM_STATIC=1)

DISABLE_WARNINGS(implicit-fallthrough)

IF (HTTPS_BACKEND STREQUAL "SecureTransport")
	ADD_DEFINITIONS(-DCRYPT_COMMONCRYPTO)
	SET(SRC_NTLMCLIENT_CRYPTO "crypt_commoncrypto.c")
	# CC_MD4 has been deprecated in macOS 10.15.
	SET_SOURCE_FILES_PROPERTIES("crypt_commoncrypto.c" COMPILE_FLAGS "-Wno-deprecated")
ELSEIF (HTTPS_BACKEND STREQUAL "OpenSSL")
	ADD_DEFINITIONS(-DCRYPT_OPENSSL)
	INCLUDE_DIRECTORIES(${OPENSSL_INCLUDE_DIR})
	SET(SRC_NTLMCLIENT_CRYPTO "crypt_openssl.c")
ELSEIF (HTTPS_BACKEND STREQUAL "mbedTLS")
	ADD_DEFINITIONS(-DCRYPT_MBEDTLS)
	SET(SRC_NTLMCLIENT_CRYPTO "crypt_mbedtls.c")
ELSE ()
	MESSAGE(FATAL_ERROR "Unable to use libgit2's HTTPS backend (${HTTPS_BACKEND}) for NTLM crypto")
ENDIF()

ADD_LIBRARY(ntlmclient OBJECT ${SRC_NTLMCLIENT} ${SRC_NTLMCLIENT_CRYPTO})

## libgit2 1.0.1+dfsg.1

=== debian/changelog ===
libgit2 (1.0.1+dfsg.1-3) unstable; urgency=medium

  * Upload to unstable.
    - Transition v1.x. (cf: #971571)

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 04 Dec 2020 23:34:22 +0530

libgit2 (1.0.1+dfsg.1-1) experimental; urgency=medium

  [ Utkarsh Gupta ]
  * New upstream version 1.0.1+dfsg.1.
  * Update symbols file to add git_worktree_prune_init_options@Base.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Drop transition for old debug package migration.
  * Fix day-of-week for changelog entry 0.19.0-2.

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 09 Oct 2020 21:05:33 +0530

libgit2 (1.0.0+dfsg.1-2) experimental; urgency=medium

  [ Utkarsh Gupta ]
  * Add Build-Depends-Package: libgit2-dev to libgit2-1.0.symbols

  [ Ximin Luo ]
  * Add missing libgit2-dev: Depends: libpcre3-dev. (Closes: #961952)

 -- Ximin Luo <infinity0@debian.org>  Fri, 02 Oct 2020 03:30:36 +0100

libgit2 (1.0.0+dfsg.1-1) experimental; urgency=medium

  * New upstream version 1.0.0+dfsg.1
  * Library transition to 1.0.0
  * Drop patch as it is merged upstream

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 10 Apr 2020 02:21:10 +0530

libgit2 (0.99.0+dfsg.1-1) experimental; urgency=medium

  [ Utkarsh Gupta ]
  * New upstream version 0.99.0+dfsg.1
  * Use pcre2 as REGEX_BACKEND
  * Add patch to fix installation in wrong location
  * Add BD on libpcre2-dev
  * Add -DUSE_NTLMCLIENT and -DUSE_HTTP_PARSER flags to CMake
  * Library transition from 28 to 99
  * Fix package-name-doesnt-match-sonames
  * Fix d/copyright wrt the new release
  * Add Rules-Requires-Root: no

  [ Sudip Mukherjee ]
  * Revert "Use pcre2 as REGEX_BACKEND"
  * Add dependency on ca-certificates and libpcre3-dev
  * Add ci
  * fix symbols file

 -- Utkarsh Gupta <utkarsh@debian.org>  Thu, 26 Mar 2020 18:25:16 +0530

=== debian/control ===
--- 
+++ 
@@ -13,22 +13,25 @@
                libmbedtls-dev,
                libssh2-1-dev,
                libhttp-parser-dev,
-               libkrb5-dev
+               libpcre3-dev,
+               libkrb5-dev,
+               ca-certificates
 Standards-Version: 4.5.0
 Homepage: https://libgit2.github.com/
 Vcs-Git: https://salsa.debian.org/debian/libgit2.git
 Vcs-Browser: https://salsa.debian.org/debian/libgit2
-
+Rules-Requires-Root: no
 
 Package: libgit2-dev
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libgit2-28 (= ${binary:Version}),
+Depends: libgit2-1.0 (= ${binary:Version}),
          zlib1g-dev,
          libmbedtls-dev,
          libssh2-1-dev,
          libhttp-parser-dev,
+         libpcre3-dev,
          ${shlibs:Depends},
          ${misc:Depends}
 Description: low-level Git library (development files)
@@ -38,7 +41,7 @@
  .
  This package contains the development files for libgit2.
 
-Package: libgit2-28
+Package: libgit2-1.0
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}

## libgit2 1.1.0%2Bdfsg.1

=== debian/watch ===
version=3
opts=compression=xz,repack,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libgit2-$1\.tar\.gz/,dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg.1 \
  https://github.com/libgit2/libgit2/releases .*/v?([\d.]*)\.tar\.gz

## libgit2 1.1.0+dfsg.1

=== debian/changelog ===
libgit2 (1.1.0+dfsg.1-4.1ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: Improper Verification of Cryptographic Signature
    - debian/patches/CVE-2023-22742.patch: perform host key checking
      by default when using ssh.
    - CVE-2023-22742
  * SECURITY UPDATE: use-after-free
    - debian/patches/CVE-2024-24577.patch: correct index check in
      has_dir_name function used by git_index_add.
    - CVE-2024-24577

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Wed, 28 Feb 2024 08:11:53 +0100

libgit2 (1.1.0+dfsg.1-4.1build1) jammy; urgency=medium

  * No-change rebuild against libmbedcrypto7

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 18 Feb 2022 23:44:34 +0000

libgit2 (1.1.0+dfsg.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix autopkgtest regression with CMake 3.19+ (Closes: #994494)

 -- Timo Röhling <roehling@debian.org>  Tue, 05 Oct 2021 20:43:28 +0200

libgit2 (1.1.0+dfsg.1-4) unstable; urgency=medium

  * Source-only upload for migration.

 -- Utkarsh Gupta <utkarsh@debian.org>  Wed, 06 Jan 2021 22:58:58 +0530

libgit2 (1.1.0+dfsg.1-3) unstable; urgency=medium

  [ Cédric Boutillier ]
  * Provide binary package for libgit2 fixtures (Closes: #972574)
  * install as examples

  [ Utkarsh Gupta ]
  * Wrap description wrt line length limitation

 -- Utkarsh Gupta <utkarsh@debian.org>  Sun, 27 Dec 2020 10:06:10 +0530

libgit2 (1.1.0+dfsg.1-2) unstable; urgency=medium

  * Upload to unstable.
    - Transition v1.x. (cf: #971571)
  * Bump Standards-Version to 4.5.1

 -- Utkarsh Gupta <utkarsh@debian.org>  Wed, 09 Dec 2020 15:09:10 +0530

libgit2 (1.1.0+dfsg.1-1) experimental; urgency=medium

  * New upstream version 1.1.0+dfsg.1
  * Update branching information in d/gbp.conf
  * Refresh d/patches
  * Drop patch that has been merged upstream
  * Library transition from 1.0 to 1.1
  * Update symbols file
  * Drop Russell Sim from uploaders' field
    - Thank you, Russell Sim, for all your work so far!

 -- Utkarsh Gupta <utkarsh@debian.org>  Mon, 07 Dec 2020 14:21:42 +0530

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: libgit2
 Section: libs
 Priority: optional
-Maintainer: Utkarsh Gupta <utkarsh@debian.org>
-Uploaders: Russell Sim <russell.sim@gmail.com>,
-           Pirate Praveen <praveen@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Utkarsh Gupta <utkarsh@debian.org>
+Uploaders: Pirate Praveen <praveen@debian.org>
 Build-Depends: debhelper-compat (= 12),
                python3-minimal:any,
                pkg-config,
@@ -16,7 +16,7 @@
                libpcre3-dev,
                libkrb5-dev,
                ca-certificates
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://libgit2.github.com/
 Vcs-Git: https://salsa.debian.org/debian/libgit2.git
 Vcs-Browser: https://salsa.debian.org/debian/libgit2
@@ -26,7 +26,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libgit2-1.0 (= ${binary:Version}),
+Depends: libgit2-1.1 (= ${binary:Version}),
          zlib1g-dev,
          libmbedtls-dev,
          libssh2-1-dev,
@@ -41,7 +41,7 @@
  .
  This package contains the development files for libgit2.
 
-Package: libgit2-1.0
+Package: libgit2-1.1
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -51,3 +51,17 @@
  libgit2 is a portable, pure C implementation of the Git
  distributed version control system core methods provided as a
  re-entrant link-able library with a solid API.
+
+Package: libgit2-fixtures
+Architecture: all
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
+Description: low-level Git library - test suite examples
+ libgit2 is a portable, pure C implementation of the Git
+ distributed version control system core methods provided as a
+ re-entrant link-able library with a solid API.
+ .
+ This package provides the test examples of the library, which
+ can be useful for other pieces of software relying on libgit2,
+ for testing purposes.

=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,9 @@
 		-DUSE_GSSAPI:BOOL=ON \
 		-DTHREADSAFE:BOOL=ON \
 		-DBUILD_CLAR:BOOL=ON \
+		-DUSE_NTLMCLIENT=OFF \
+		-DENABLE_REPRODUCIBLE_BUILDS=ON \
+		-DUSE_HTTP_PARSER=system \
 		-DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)
 
 	dh_auto_configure --builddirectory=build-debian-devel -- \
@@ -35,6 +38,9 @@
 		-DUSE_GSSAPI:BOOL=ON \
 		-DBUILD_CLAR:BOOL=OFF \
 		-DBUILD_SHARED_LIBS:BOOL=OFF \
+		-DUSE_NTLMCLIENT=OFF \
+		-DENABLE_REPRODUCIBLE_BUILDS=ON \
+		-DUSE_HTTP_PARSER=system \
 		-DLIB_INSTALL_DIR:STRING=lib/$(DEB_HOST_MULTIARCH)
 
 
@@ -55,9 +61,6 @@
 	mkdir -p build-debian-devel/tmp
 	dh_auto_test --builddirectory=build-debian-devel
 
-override_dh_strip:
-	dh_strip --dbgsym-migration='libgit2-dbg (<< 0.26.0+dfsg.1-1~)'
-
 override_dh_installexamples:
 	dh_installexamples --exclude .gitignore

=== debian/tests/control ===
Test-Command: cmake debian/tests;make;./libgit2_test
Depends: @, cmake, gcc, g++
